package no.ntnu.idatt1002.demo.data.Budget;

import java.util.ArrayList;
import java.util.List;

public class BudgetRegister {
  private final List<String> budgetNames;

  public BudgetRegister() {
    budgetNames = new ArrayList<>();
  }

  public List<String> getBudgetNames() {
    return this.budgetNames;
  }

  public void addBudgetName(String name) {
    if (name == null) throw new IllegalArgumentException("Name cannot be null");
    if (name.isBlank()) throw new IllegalArgumentException("Name cannot be blank");
    //if(budgetNames.contains(name)) throw new IllegalArgumentException("Duplicate entry");
    budgetNames.add(name);
  }

  public void removeBudgetName(String name) {
    if (name == null) throw new IllegalArgumentException("Name cannot be null");
    if (name.isBlank()) throw new IllegalArgumentException("Name cannot be blank");
    budgetNames.add(name);
  }

  @Override
  public String toString() {
    StringBuilder namesToString = new StringBuilder();
    budgetNames.forEach(name -> namesToString.append(name).append("\n"));
    return namesToString.toString();
  }
}
