package no.ntnu.idatt1002.demo.data.recipes;

/**
 * The enum class defines a set of valid units of measurements related to the ingredients and recipes.
 * The label property of each constant provides a lower-case representation of each unit that can be used in
 * presentation to the user.
 *
 * @author hannesofie
 */

public enum MeasuringUnit {

    DL("dl."),
    L("l."),
    TSP("tsp."),
    TBS("tbs."),
    GR("gr."),
    KG("kg."),
    PC("pieces"),
    CAN("can"),
    SLICE("slice"),
    PKG("pack"),
    CB("cubes");

    public final String label;

    /**
     * The constructor of each enum constant takes in a string representation of the constant that is more suited for
     * presentation at the frontend.
     * @param label Lower case representation of the unit of measure.
     */
    MeasuringUnit(String label) {
        this.label = label;
    }
}
